import { __awaiter } from "tslib";
import './shims.js';
// 0SERVER gets replaced by real import during build
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
import { Server } from '0SERVER';
import { getRequest, setResponse } from '@sveltejs/kit/node';
const BODY_SIZE_LIMIT_V1 = 10485760;
const BODY_SIZE_LIMIT_V2 = 33554432;
export function init(manifest, v2) {
    const server = new Server(manifest);
    let initPromise = server.init({
        env: process.env,
    });
    return (req, res) => __awaiter(this, void 0, void 0, function* () {
        if (initPromise !== null) {
            yield initPromise;
            initPromise = null;
        }
        let request;
        try {
            request = yield getRequest({
                base: getOrigin(req.headers),
                request: req,
                bodySizeLimit: v2 ? BODY_SIZE_LIMIT_V2 : BODY_SIZE_LIMIT_V1,
            });
        }
        catch (err) {
            res.statusCode = err.status || 400;
            res.end('Invalid request body');
            return;
        }
        yield setResponse(res, yield server.respond(request, {
            getClientAddress() {
                var _a;
                return (req.headers['X-Forwarded-For'].split(',')[0] ||
                    ((_a = req.socket) === null || _a === void 0 ? void 0 : _a.remoteAddress));
            },
        }));
    });
}
function getOrigin(headers) {
    const protocol = 'https';
    const host = headers['host'];
    return `${protocol}://${host}`;
}
